VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsPLSection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Module     : clsPLSection
' Description:
' Procedures : InitSection(curSection As Section, lngLineBorderWidthDefault As Long)
'              Get BottomMargin()
'              Get SectionIndex()
'              Let SectionIndex(NewValue As Integer)
'              Get SelectControlsMode()
'              Let SelectControlsMode(fSelectCtls As Boolean)
'              Get TopMargin()
'              Get zSection()
'              Draw(pSection As ClsSectionProperties)
'              DrawBorder(pSectionProperties As ClsSectionProperties)
'              DrawVerticaLines(pSectionProperties As ClsSectionProperties)
'              mSection_Print(pintCancel As Integer, pIntCount As Integer)
'              mSectionDetail_Format(pintCancel As Integer, pintFormatCount As Integer)

' Modified   :
' 01/22/02 S Cleaned with Total Visual CodeTools 2000
'
' --------------------------------------------------
Option Compare Database
Option Explicit
Private Const mcstrModule As String = "clsPLSection"
' The sections here require a different interface than
' the standard _SectionInReport. The PageHeader & PageFooter
' have their own object interface: _PageHdrFtrInReport
' If you try to enter these Type declarations in another module
' you'll need to do it like this:
' Access.[_SectionInReport] AND  Access.[_PageHdrFtrInReport]
' since the underscore character is an illegal char for
' prfexing a Type declaration.


Private WithEvents mSection  As Access.[_SectionInReport]
Attribute mSection.VB_VarHelpID = -1
Private WithEvents mSectionPageHeader As Access.[_PageHdrFtrInReport]
Attribute mSectionPageHeader.VB_VarHelpID = -1
Private WithEvents mSectionPageFooter As Access.[_PageHdrFtrInReport]
Attribute mSectionPageFooter.VB_VarHelpID = -1
Private mobjGenSection As Object

Private mintLineBorderWidthDefault As Integer
Private mfSelectControlsMode As Boolean
Private mIntSectionIndex As Integer

' Custom Properties for this Section
Private mfVerticalLines As Boolean
Private mintVerticalLinesWidth As Integer
Private mintVerticalLineMargin As Integer
Private mintVerticalLinesDrawStyle As Integer
Private mintVerticallinesDrawMode As Integer
Private mlngVerticalLinesColor As Long

Private mfBorder As Boolean
Private mintBorderWidth As Integer
Private mintBorderDrawStyle As Integer
Private mintBorderDrawMode As Integer
Private mlngBorderColor As Long
Private mlngLeftMargin As Long
Private mlngRightBorderPosition As Long
Private mlngLeftBorderPosition As Long
Private mlngSectionName As Long

Private mstrSectionName As String

Public Sub InitSection(curSection As Section, plMain As clsPrintLinesV2, intSectionNum As Integer)
    ' Comments  :
    ' Parameters: curSection
    '             lngLineBorderWidthDefault -
    ' Modified  :
    '
    ' --------------------------------------------------
    
    
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If Not (curSection Is Nothing) Then
        Select Case intSectionNum
            Case acPageHeader
                Set mSectionPageHeader = curSection
                Set mobjGenSection = curSection
                With mSectionPageHeader
                    .OnFormat = "[Event Procedure]"
                    .OnPrint = "[Event Procedure]"
                End With
            Case acPageFooter
                Set mSectionPageFooter = curSection
                Set mobjGenSection = curSection
                With mSectionPageFooter
                    .OnFormat = "[Event Procedure]"
                    .OnPrint = "[Event Procedure]"
                End With
            Case Else
                Set mSection = curSection
                Set mobjGenSection = curSection
                mSection.OnFormat = "[Event Procedure]"
                mSection.OnPrint = "[Event Procedure]"
        End Select
        mstrSectionName = curSection.name
        mIntSectionIndex = intSectionNum
        'initialize all other properties based on parent properties
        With plMain
            mintVerticalLineMargin = .VerticalLineMargin
            mfBorder = .Border
            mintLineBorderWidthDefault = .LineBorderWidthDefault
            mintBorderWidth = .BorderWidth
            mfVerticalLines = .VerticalLines
            mintVerticalLinesWidth = .LineBorderWidthDefault
            mlngBorderColor = .BorderColor
            mlngVerticalLinesColor = .VerticalLinesColor
            mintBorderDrawMode = .BorderDrawMode
            mintBorderDrawStyle = .BorderDrawStyle
            mintVerticallinesDrawMode = .VerticallinesDrawMode
            mintVerticalLinesDrawStyle = .VerticalLinesDrawStyle
        End With
    End If
    
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "InitSection", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Public Property Get Border() As Boolean
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Boolean
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    Border = mfBorder
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "Border", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let Border(BD As Boolean)
    ' Comments  :
    ' Parameters: BD -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Flag to signal whether we actually render
    ' the Border or not.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    mfBorder = BD
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "Border", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get BorderColor() As Long
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Long
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    BorderColor = mlngBorderColor
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderColor", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let BorderColor(BDC As Long)
    ' Comments  :
    ' Parameters: BDC -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object ForeColor property.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    mlngBorderColor = BDC
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderColor", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get BorderDrawMode() As Integer
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Integer
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    BorderDrawMode = mintBorderDrawMode
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderDrawMode", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let BorderDrawMode(BDM As Integer)
    ' Comments  :
    ' Parameters: BDS -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object DrawMode property.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If BDM < 0 Then
        mintBorderWidth = 0
    End If
    If BDM > 16 Then
        mintBorderWidth = 0
    End If
    mintBorderDrawMode = BDM
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderDrawMode", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get BorderDrawStyle() As Integer
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Integer
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    BorderDrawStyle = mintBorderDrawStyle
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderDrawStyle", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let BorderDrawStyle(BDS As Integer)
    ' Comments  :
    ' Parameters: BDS -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object DrawStyle property.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If BDS < 0 Then
        mintBorderWidth = 0
    End If
    If BDS > 6 Then
        mintBorderWidth = 6
    End If
    mintBorderDrawStyle = BDS
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderDrawStyle", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get BorderWidth() As Integer
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Integer
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    BorderWidth = mintBorderWidth
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderWidth", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let BorderWidth(BDW As Integer)
    ' Comments  :
    ' Parameters: BDW -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object DrawWidth property.
    ' Expresses in output Device Pixels.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If BDW < 0 Then
        mintBorderWidth = 2
    End If
    If BDW > 36 Then
        mintBorderWidth = 2
    End If
    mintBorderWidth = BDW
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "BorderWidth", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get BottomMargin() As Long
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Long
    ' Modified  :
    '
    ' --------------------------------------------------
    ' We must recheck latest MIPS property to
    ' allow for using changing Margins via
    ' Page Setup menu during Print Preview
    
    On Error Resume Next
    
    ' Var will be set to the Margin you
    ' set for the Bottom of the Page
    ' and Top of the Page via
    ' the Page Setup Menu
    ' Expressed in TWIPS.
    
    Dim lngBMargin As Long
    ' PrtMips structs
    Dim MipsTemp As PrtMipsTemp
    Dim MIPS As PrinterMips
    
    ' See Access help for PrtMip
    ' Our Class must always have a valid
    ' pointer to a Detail Section object
    MipsTemp.strMips = mSection.Parent.PrtMip
    LSet MIPS = MipsTemp
    
    ' Copy value into our page Margin vars
    lngBMargin = MIPS.lngBottom
    BottomMargin = lngBMargin
    
    
End Property

Public Property Get LeftBorderPosition() As Long
    ' Comments  :
    ' Parameters:
    ' Returns   : Long
    ' Created   : 01/24/02 09:24 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    LeftBorderPosition = mlngLeftBorderPosition
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "LeftBorderPosition", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Let LeftBorderPosition(lngLeftBorderPosition As Long)
    ' Comments  :
    ' Parameters:
    ' Created   : 01/24/02 09:24 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    mlngLeftBorderPosition = lngLeftBorderPosition
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "LeftBorderPosition", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Get LineBorderWidthDefault() As Integer
    ' Comments  :
    ' Parameters:
    ' Returns   : Long
    ' Created   : 01/24/02 12:27 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    LineBorderWidthDefault = mintLineBorderWidthDefault
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "LineBorderWidthDefault", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Let LineBorderWidthDefault(intLineBorderWidthDefault As Integer)
    ' Comments  :
    ' Parameters:
    ' Created   : 01/24/02 12:27 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    mintLineBorderWidthDefault = intLineBorderWidthDefault
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "LineBorderWidthDefault", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Get plSection() As Object
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Object
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If Not mSection Is Nothing Then
        Set plSection = mSection
    End If
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "plSection", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Set plSection(obj As Object)
    ' Comments  :
    ' Parameters: obj -
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If obj Is Nothing Then
        MsgBox "Error...you must supply a reference to a valid Report Section!", vbCritical, _
        "Init Report Section object ERROR"
        Exit Property
    End If
    Set mSection = obj
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "plSection", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get RightBorderPosition() As Long
    ' Comments  :
    ' Parameters:
    ' Returns   : Long
    ' Created   : 01/24/02 09:24 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    RightBorderPosition = mlngRightBorderPosition
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "RightBorderPosition", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Let RightBorderPosition(lngRightBorderPosition As Long)
    ' Comments  :
    ' Parameters:
    ' Created   : 01/24/02 09:24 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    mlngRightBorderPosition = lngRightBorderPosition
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "RightBorderPosition", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Get SectionIndex() As Integer
    ' Comments  :
    ' Parameters:
    ' Returns   : Integer
    ' Created   : 01/21/02 11:29 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    SectionIndex = mIntSectionIndex
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "SectionIndex", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Let SectionIndex(NewValue As Integer)
    ' Comments  :
    ' Parameters:
    ' Created   : 01/21/02 11:29 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    mIntSectionIndex = NewValue
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "SectionIndex", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Get SectionName() As String
    ' Comments  :
    ' Parameters:
    ' Returns   : String
    ' Created   : 01/24/02 11:02 S
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    SectionName = mstrSectionName
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "SectionName", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Get SelectControlsMode() As Boolean
    ' Comments  :
    ' Parameters:
    ' Returns   : Boolean
    ' Created   : 09/21/01 16:09 SMD
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    SelectControlsMode = mfSelectControlsMode
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "SelectControlsMode", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Let SelectControlsMode(fSelectCtls As Boolean)
    ' Comments  :
    ' Parameters:
    ' Created   : 09/21/01 16:09 SMD
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    mfSelectControlsMode = fSelectCtls
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "SelectControlsMode", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
End Property

Public Property Get TopMargin() As Long
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Long
    ' Modified  :
    '
    ' --------------------------------------------------
    ' We must recheck latest MIPS property to
    ' allow for using changing Margins via
    ' Page Setup menu during Print Preview
    
    'On Error Resume Next
    
    ' Var will be set to the Margin you
    ' set for the Bottom of the Page
    ' and Top of the Page via
    ' the Page Setup Menu
    ' Expressed in TWIPS.
    
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    Dim lngTMargin As Long
    ' PrtMips structs
    Dim MipsTemp As PrtMipsTemp
    Dim MIPS As PrinterMips
    
    ' See Access help for PrtMip
    ' Our Class must always have a valid
    ' pointer to a Detail Section object
    MipsTemp.strMips = mobjGenSection.Parent.PrtMip
    LSet MIPS = MipsTemp
    
    ' Copy value into our page Margin var
    lngTMargin = MIPS.lngTop
    TopMargin = lngTMargin
    
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "TopMargin", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get VerticalLineMargin() As Integer
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Integer
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    VerticalLineMargin = mintVerticalLineMargin
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLineMargin", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let VerticalLineMargin(vlt As Integer)
    ' Comments  :
    ' Parameters: vlt -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Our Margin for a starting position to the left
    ' edge of the control.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If vlt < 0 Then
        vlt = 0
    End If
    If vlt > 1440 Then
        vlt = 60
    End If
    mintVerticalLineMargin = vlt
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLineMargin", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get VerticalLines() As Boolean
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Boolean
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    VerticalLines = mfVerticalLines
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLines", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let VerticalLines(VL As Boolean)
    ' Comments  :
    ' Parameters: VL -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Flag to signal whether we actaully render
    ' the Vertical Lines or not.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    mfVerticalLines = VL
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLines", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get VerticalLinesColor() As Long
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Long
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    VerticalLinesColor = mlngVerticalLinesColor
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLinesColor", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let VerticalLinesColor(BDC As Long)
    ' Comments  :
    ' Parameters: BDC -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object ForeColor property.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    mlngVerticalLinesColor = BDC
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLinesColor", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get VerticallinesDrawMode() As Integer
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Integer
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    VerticalLinesDrawStyle = mintVerticalLinesDrawStyle
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticallinesDrawMode", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let VerticallinesDrawMode(BDS As Integer)
    ' Comments  :
    ' Parameters: BDS -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object DrawMode property.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If BDS < 0 Then
        mintVerticalLinesWidth = 0
    End If
    If BDS > 16 Then
        mintVerticalLinesWidth = 0
    End If
    mintVerticalLinesDrawStyle = BDS
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticallinesDrawMode", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get VerticalLinesDrawStyle() As Integer
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Integer
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    VerticalLinesDrawStyle = mintVerticalLinesDrawStyle
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLinesDrawStyle", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let VerticalLinesDrawStyle(BDS As Integer)
    ' Comments  :
    ' Parameters: BDS -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object DrawStyle property.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If BDS < 0 Then
        mintVerticalLinesDrawStyle = 0
    End If
    If BDS > 6 Then
        mintVerticalLinesDrawStyle = 6
    End If
    mintVerticalLinesDrawStyle = BDS
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLinesDrawStyle", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Get VerticalLinesWidth() As Integer
    ' Comments  :
    ' Parameters:  -
    ' Returns   : Integer
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    VerticalLinesWidth = mintVerticalLinesWidth
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLinesWidth", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Public Property Let VerticalLinesWidth(VLW As Integer)
    ' Comments  :
    ' Parameters: VLW -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' Corresponds to the Report object DrawWidth property.
    ' Expresses in output Device Pixels.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    If VLW < 0 Then
        mintVerticalLinesWidth = 2
    End If
    If VLW > 36 Then
        mintVerticalLinesWidth = 2
    End If
    mintVerticalLinesWidth = VLW
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Property
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "VerticalLinesWidth", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Property

Private Sub Class_Terminate()
    ' Comments  :
    ' Parameters:  -
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    Set mSection = Nothing
    Set mSectionPageHeader = Nothing
    Set mSectionPageFooter = Nothing
    Set mobjGenSection = Nothing
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "Class_Terminate", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub Draw(pSection As Section)
    ' Comments  :
    ' Parameters: pSection -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' We set this as a seperate SUB to allow for easier
    ' extensibility.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    DrawVerticaLines pSection
    DrawBorder pSection
    
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "Draw", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub DrawBorder(pSection As Section)
    ' Comments  :
    ' Parameters: pSectionProperties -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' This SUB draw a Border around the entire Section.
    ' The obj passed to this SUB contains an object
    ' reference to the Report Section and the custom
    ' properties we require to draw the Border Lines.
    
    ' Var needed to allow us to set this value to ZERO to accomodate
    ' the Report Header and Page Header Sections.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    Dim intPageHeaderHeight As Integer
    'Revised - SMD
    '   Default left and right border positions are Left=0 and Right=Report Width
    '   Added new editable properties to allow these positions to be overridden with
    '   specific left and right positions.
    Dim lngLeft As Long
    Dim lngRight As Long
    ' To save on typing we'll declare a local
    ' object to hold our Report Section.
    Dim lngTmpTopMargin As Long
    Dim lngStart As Long
    ' If Boolean Flag to render Border Lines is False - EXIT
    If Me.Border Then
        ' Init our local Section object
        ' Set the Report object's properties that
        ' effect how lines drawn with the Line method
        ' are rendered.
        lngTmpTopMargin = TopMargin
        With pSection.Parent
            ' Set the Parent Report object's DrawWidth property
            .DrawWidth = Me.BorderWidth
            ' Use Default if not initialized
            If .DrawWidth = 0 Then
                .DrawWidth = mintLineBorderWidthDefault
                Me.BorderWidth = mintLineBorderWidthDefault
            End If
            ' Set Line Style
            .DrawStyle = Me.BorderDrawStyle
            ' Set Line Color
            .ForeColor = Me.BorderColor
            If mlngLeftBorderPosition > 0 Then
                lngLeft = mlngLeftBorderPosition + mintVerticalLineMargin
            Else
                lngLeft = 0
            End If
            If mlngRightBorderPosition > 0 Then
                lngRight = mlngRightBorderPosition + mintVerticalLineMargin
            Else
                lngRight = pSection.Parent.Width
            End If
        End With
        ' Grab the PageHeader Section Height if it exists
        On Error Resume Next
        intPageHeaderHeight = Nz(pSection.Parent.Section(acPageHeader).Height, 0)
        On Error GoTo Proc_Err
        ' If this Section is the Report or Page Header then we want to set
        ' PageHeaderHeight to 0 as it is not required for
        ' the calculations for these 2 Sections.
        
        If mIntSectionIndex = acHeader _
            Or mIntSectionIndex = acPageHeader Then
            intPageHeaderHeight = 0
        End If
        
        ' Let's draw a box around this Section
        With pSection.Parent
            'If not a CanGrow carry over from previous page then
            If .Top >= TopMargin + intPageHeaderHeight Then
                'lngWidth = .Width
                'lngHeight = .Height
                pSection.Parent.Line (lngLeft, 0)-(lngRight, pSection.Parent.Height), , B
                ' - SectionProperties.BorderWidth), , B
            Else
                ' CanGrow Carry over from previous Page:
                If .Top < 0 Then
                    lngStart = intPageHeaderHeight + TopMargin + Abs(.Top)
                    ' Here we have a negative Top value signifying a CarryOver
                    ' from the previous page.
                    pSection.Parent.Line (lngLeft, lngStart)-(lngRight, lngStart + pSection.Parent.Height), , B
                Else
                    ' Here we have a Top value Less than the smallest
                    ' possible starting postion relative to the top of the page.
                    ' This signifies a CarryOver from the previous page.
                    lngStart = intPageHeaderHeight + TopMargin - (.Top)
                    pSection.Parent.Line (lngLeft, lngStart)-(lngRight, lngStart + .Height), , B
                End If
            End If
        End With
    End If
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "DrawBorder", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub DrawVerticaLines(pSection As Section)
    ' Comments  :
    ' Parameters: pSectionProperties -
    ' Modified  :
    '
    ' --------------------------------------------------
    ' This SUB draw a vertical line to seperate each
    ' control in this Section.
    ' The obj passed to this SUB contains an object
    ' reference to the Report Section and the custom
    ' properties we require to draw the Vertical Lines.
    
    ' To save on typing we'll declare a local
    ' object to hold our Report Section.
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    ' Temp var so we can loop through controls in this Section.
    Dim CtlDetail As Control
    ' Var needed to allow us to set this value to ZERO to accomodate
    ' the Report Header and Page Header Sections.
    Dim intPageHeaderHeight As Integer
    
    ' Temp var so we only have to execute this
    ' property once for the entire loop
    Dim intTmpTopMargin As Integer
    
    ' If Boolean Flag to render Vertical Lines is False - EXIT
    If Me.VerticalLines Then
        ' Init our local Section object
        With pSection.Parent
            ' Set the Report object's properties that
            ' effect how lines drawn with the Line method
            ' are rendered.
            ' Set the Parent Report object's DrawWidth property
            .DrawWidth = Me.VerticalLinesWidth
            ' Use Default if not initialized
            If .DrawWidth = 0 Then
                .DrawWidth = mintLineBorderWidthDefault
                Me.VerticalLinesWidth = mintLineBorderWidthDefault
            End If
            ' Set Line Style
            .DrawStyle = Me.VerticalLinesDrawStyle
            ' Set Line Color
            .ForeColor = Me.VerticalLinesColor
        End With
        
        ' Grab the current value of this prop.
        intTmpTopMargin = TopMargin
        
        ' Grab the PageHeader Section Height if it exists
        On Error Resume Next
        intPageHeaderHeight = Nz(pSection.Parent.Section(acPageHeader).Height, 0)
        On Error GoTo Proc_Err
        
        ' If this Section is the Report or Page Header then we want to set
        ' PageHeaderHeight to 0 as it is not required for
        ' the calculations for these 2 Sections..
        
        If mIntSectionIndex = acHeader _
            Or mIntSectionIndex = acPageHeader Then
            intPageHeaderHeight = 0
        End If
        'objSection.Parent.Line (0, 0)-(0, objSection.Parent.Height)
        ' Let's loop through this Section's Controls
        For Each CtlDetail In pSection.Controls
            'Added by SMD to allow more ctl over where vertical lines occur
            If (Not mfSelectControlsMode And CtlDetail.Tag <> "NOVertical") _
                Or (mfSelectControlsMode And CtlDetail.Tag = "VerticalLine") Then
                With CtlDetail
                    'If normal no CanGrow or Carryover from previous page
                    If pSection.Parent.Top >= intTmpTopMargin + intPageHeaderHeight Then
                        pSection.Parent.Line ((.Left + .Width + Me.VerticalLineMargin), 0)-(.Left + .Width + _
                        Me.VerticalLineMargin, pSection.Parent.Height) ' - SectionProperties.VerticalLinesWidth)
                        ' Here we have a Top value Less than the smallest
                        ' possible starting postion relative to the top of the page.
                        ' This signifies a CarryOver from the previous page.
                    ElseIf pSection.Parent.Top > 0 Then
                        pSection.Parent.Line ((.Left + .Width + Me.VerticalLineMargin), _
                        intPageHeaderHeight + intTmpTopMargin - _
                        (pSection.Parent.Top))-Step(0, pSection.Parent.Height) ' - SectionProperties.VerticalLinesWidth)
                    Else
                        ' Here we have a negative Top value signifying a CarryOver
                        ' from the previous page.
                        pSection.Parent.Line ((.Left + .Width + Me.VerticalLineMargin), _
                        intPageHeaderHeight + intTmpTopMargin + Abs(pSection.Parent.Top)) _
                        -Step(0, pSection.Parent.Height) ' - Me.VerticalLinesWidth)
                    End If
                End With
            End If
        Next
    End If
    
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "DrawVerticaLines", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub mSection_Format(pintCancel As Integer, pintFormatCount As Integer)
    ' Comments  :
    ' Parameters: pintCancel
    '             pintFormatCount -
    ' Modified  :
    '
    ' --------------------------------------------------
    'mSection.Parent.DrawMode = Me.BorderDrawMode
    ' Draw mGenSection
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "mSection_Format", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub mSection_Print(pintCancel As Integer, pIntCount As Integer)
    ' Comments  :
    ' Parameters: pintCancel
    '             pIntCount -
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    mSection.Parent.DrawMode = Me.BorderDrawMode
    Draw mobjGenSection
    
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "mSection_Print", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub mSectionPageFooter_Format(pintCancel As Integer, pintFormatCount As Integer)
    ' Comments  :
    ' Parameters: pintCancel
    '             pintFormatCount -
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    mSectionPageFooter.Parent.DrawMode = Me.BorderDrawMode
    Draw mobjGenSection
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "mSectionPageFooter_Format", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub mSectionPageFooter_Print(pintCancel As Integer, pIntCount As Integer)
    ' Comments  :
    ' Parameters: pintCancel
    '             pIntCount -
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    
    'mSectionPageFooter.Parent.DrawMode = Me.BorderDrawMode
    Draw mSectionPageFooter
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "mSectionPageFooter_Print", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub mSectionPageHeader_Format(pintCancel As Integer, pintFormatCount As Integer)
    ' Comments  :
    ' Parameters: pintCancel
    '             pintFormatCount -
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    mSectionPageHeader.Parent.DrawMode = Me.BorderDrawMode
    Draw mobjGenSection
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "mSectionPageHeader_Format", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub

Private Sub mSectionPageHeader_Print(pintCancel As Integer, pIntCount As Integer)
    ' Comments  :
    ' Parameters: pintCancel
    '             pintCount -
    ' Modified  :
    '
    ' --------------------------------------------------
    'TVCodeTools ErrorEnablerStart
    On Error GoTo Proc_Err
    'TVCodeTools ErrorEnablerEnd
    'mSectionPageHeader.Parent.DrawMode = Me.BorderDrawMode
    Draw mSectionPageHeader
    
    'TVCodeTools ErrorHandlerStart
Proc_Exit:
    Exit Sub
    
Proc_Err:
    Select Case Err.Number
        Case Else
            Select Case ErrorDisplay(Err.Number, Error$, mcstrModule, "mSectionPageHeader_Print", Erl())
                Case errContinue
                    Resume Next
                Case errexit
                    Resume Proc_Exit
            End Select
    End Select
    'TVCodeTools ErrorHandlerEnd
    
End Sub


